<?php
/*
Plugin Name: WatuPRO Simple Designer
Plugin URI: 
Description: A small plugin that lets you modify the design of the quizzes 
Author: Kiboko Labs
Version: 1.1
Author URI: http://calendarscripts.info/
License: GPLv2 or later
*/

define( 'WTPSD_PATH', dirname( __FILE__ ) );
define( 'WTPSD_RELATIVE_PATH', dirname( plugin_basename( __FILE__ )));
define( 'WTPSD_URL', plugin_dir_url( __FILE__ ));

require(WTPSD_PATH.'/controllers/ajax.php');
require(WTPSD_PATH.'/controllers/shortcodes.php');

register_activation_hook(__FILE__, 'wtpsd_activate');
add_action('init', 'wtpsd_init');

function wtpsd_activate() {
	update_option('wtpsd_default_color', '#FFFAEF');
	update_option('wtpsd_checked_color', '#BBDDFF');
	update_option('wtpsd_display_result', '');
}

function wtpsd_init() {
	global $wpdb;
	
	wp_enqueue_script('jquery');
   
	add_filter('the_content', 'WTPSDAddCSS');
	add_action('watupro_admin_menu', 'wtpsd_menu');
	add_action('wp_ajax_wtpsd_get_result', 'wtpsd_get_result');
	add_action('wp_ajax_nopriv_wtpsd_get_result', 'wtpsd_get_result');	
	add_shortcode('wtpsd-category-tabs', 'wtpsd_category_tabs');
}


function WTPSDAddCSS($content) {
	if(!stristr($content, '[WATUPRO') and !strstr($content, '[wtpuc')) return $content;
	
	// adding to this quiz?
	$to_add = false;	
	$selected_quizzes = get_option('wtpsd_quizzes');
	if(empty($selected_quizzes)) return $content;
	
	foreach($selected_quizzes as $q_id) {
		if(stristr($content, '[WATUPRO '.$q_id.']') or strstr($content, '[wtpuc quiz_id='.$q_id)) $to_add = true;
	}
	
	if(!$to_add) return $content;
	
	wp_enqueue_script(
			'wtpsd-main',
			WTPSD_URL."js/main.js",
			array('jquery'),
			'1.3');
		
	$css = '.watupro-question-choice input[type="radio"].answer  {
		display: none !important;
		padding: 5px;
	} 
	
	.watupro-question-choice input[type="checkbox"].answer  {
		display: none !important;
	} 
	
	div.watupro-question-choice {
		display: block;
		cursor: pointer;
		padding: 5px;
		margin: 5px;
		background-color: '.get_option('wtpsd_default_color').';
	}
	
	.wtpsd-checked {
		background-color: '.get_option('wtpsd_checked_color').' !important;		
	}
	
	.wtpsd-correct {
		background-image:url('.plugins_url('watupro/correct.png').');
		background-repeat: no-repeat;
		background-position:  90% 50%;;
	}
	
	.wtpsd-wrong {
		background-image:url('.plugins_url('watupro/wrong.png').');
		background-repeat: no-repeat;
		background-position:  90% 50%;;
	}';
	$content .= "<!-- from WatuPRO Simple Designer--><style type='text/css'>
	$css
	</style>";

	$content .= "\n<script type='text/javascript'>
		jQuery(function() {
			WatuPRO.wtpsd_display_result = '".get_option('wtpsd_display_result')."';
		});
	</script>";

	return $content;
}

function WPTSDOptions() {
	global $wpdb;
	if(!empty($_POST['ok'])) {
		update_option('wtpsd_default_color', $_POST['default_color']);
		update_option('wtpsd_checked_color', $_POST['checked_color']);
		update_option('wtpsd_display_result', @$_POST['display_result']);
		update_option('wtpsd_display_correct', @$_POST['display_correct']);
		update_option('wtpsd_quizzes', $_POST['quizzes']);
	}
	
	// select all quizzes from WatuPro
	$quizzes = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}watupro_master ORDER BY name");	
	
	$selected_quizzes = get_option('wtpsd_quizzes');
	
	// quizzes that are paginated one page per question category
	$category_quizzes = array();
	foreach($quizzes as $quiz) {
		if($quiz->single_page == WATUPRO_PAGINATE_PAGE_PER_CATEGORY) $category_quizzes[] = $quiz;
	}
	
	$display_result = get_option('wtpsd_display_result');
	include(WTPSD_PATH.'/views/options.html.php');
}

function wtpsd_menu() {
	add_submenu_page('watupro_exams', 'Simple Designer', 'Simple Designer', 'manage_options', 'wtpsd_options', 'WPTSDOptions');
}